const Promise = require('bluebird');
const baseClass = require('../lib/baseClass');

module.exports = class Captcha extends baseClass {
    makeCaptcha(ttl, size, width, height, noise) {
        if (!ttl) ttl = 60;
        if (!size) size = 4;
        if (!width) width = 85;
        if (!height) height = 30;
        if (!noise) noise = 1;
        return new Promise((resolve, reject) => {
            this.request().get(`${this.getPath()}/request`, {
                ttl: ttl,
                size: size,
                width: width,
                height: height,
                noise: noise
            }).then(captcha => {
                resolve(captcha);
            }).catch(err => {
                reject(err);
            });
        });
    }

    verifyCaptcha(captchaCode, captchaToken) {
        return new Promise((resolve, reject) => {
            this.request().post(`${this.getPath()}/verify`, {
                code: captchaCode,
                token: captchaToken
            }).then(result => {
                resolve(result);
            }).catch(err => {
                reject(err);
            });
        });
    }

    verifyOperationToken(token) {
        return new Promise((resolve, reject) => {
            this.request().get(`${this.getPath()}/verifyOperationToken/${token}`).then(() => {
                resolve();
            }).catch(err => {
                reject(err);
            });
        });
    }
};