const Promise = require('bluebird');
const baseClass = require('../lib/baseClass');

module.exports = class Schemas extends baseClass {
    createSchema(schemaName, schemaObj) {
        return new Promise((resolve, reject) => {
            this.request().post(`${this.getPath()}/${schemaName}`, schemaObj).then(() => {
                resolve(schemaName);
            }).catch(err => {
                reject(err);
            });
        });
    }

    fetchSchemas() {
        return new Promise((resolve, reject) => {
            this.request().get(this.getPath()).then(schemas => {
                resolve(schemas);
            }).catch(err => {
                reject(err);
            });
        });
    }

    getSchema(name) {
        return new Promise((resolve, reject) => {
            this.request().get(this.getPath()).then(schemaResult => {
                resolve(schemaResult[name]);
            }).catch(err => {
                reject(err);
            });
        });
    }

    updateSchema(name, schemaObj) {
        return new Promise((resolve, reject) => {
            this.request().put(`${this.getPath()}/${name}`, schemaObj).then(() => {
                resolve();
            }).catch(err => {
                reject(err);
            });
        });
    }

    removeSchema(name) {
        return new Promise((resolve, reject) => {
            this.request().del(`${this.getPath()}/${name}`).then(() => {
                resolve();
            }).catch(err => {
                reject(err);
            });
        });
    }
};