const requestServer = require('./requestServer');
const SetHeader = require('./setHeader');

module.exports = class baseClass {
    constructor(path, headers) {
        this.path = path;
        this.headers = headers;
    }

    getPath() {
        return this.path;
    }

    getHeaders() {
        return this.headers;
    }

    request(optionalHeaders) {
        if (optionalHeaders) {
            if (!(optionalHeaders instanceof Object)) {
                throw new Error('Invalid optional headers');
            }
        } else {
            optionalHeaders = {};
        }
        let _headers = this.headers;
        let headerKeys = Object.keys(optionalHeaders);
        for (let hk of headerKeys) {
            _headers = Object.assign(_headers, SetHeader(hk, optionalHeaders[hk], _headers));
        }
        return new requestServer(_headers);
    }
};