module.exports = class SdkError extends Error {
    constructor(message, status, code) {
        super(message);
        Error.captureStackTrace(this, this.constructor);
        this.name = this.constructor.name;
        this.status = status;
        this.code = (code === undefined || code === null) ? -1 : code;
        this.body = {
            name: this.name,
            status: this.status,
            code: this.code,
            message: message
        };
    }
};
